config/routes.rb
Rails.application.routes.draw do

  #root 'static_pages#home'
  root 'events#index'

  get  '/signup',  to: 'users#new'
  post '/signup',  to: 'users#create'

  get    '/login',   to: 'sessions#new'
  post   '/login',   to: 'sessions#create'
  delete '/logout',  to: 'sessions#destroy'

  get  '/new_event',  to: 'events#new'
  post '/new_event',  to: 'events#create'

  post '/subscribe', to: 'events#subscribe'


  resources :users
  resources :events do
    get '/users', to: 'users#index'
    get '/users/invite', to: 'events#invite'
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/event.rb
class Event < ApplicationRecord
  belongs_to :creator, class_name: 'User'#, foreign_key: 'user_id'
  has_and_belongs_to_many :attendees, class_name: 'User'
  
  validates :date, presence: true
  validates :place, presence:true
  validates :description, presence:true

  scope :current, -> {where("date > ?", DateTime.now)}
  scope :past, -> {where("date < ?", DateTime.now)}
end

app/models/user.rb
class User < ApplicationRecord
  has_many :created_events, class_name: 'Event', foreign_key: 'creator_id'
  has_and_belongs_to_many :attended_events, class_name: 'Event'

  attr_accessor :remember_token
  before_save { self.email = email.downcase }
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  validates :email, presence: true, length: { maximum: 255 },
                    format: { with: VALID_EMAIL_REGEX },
                    uniqueness: { case_sensitive: false }
  has_secure_password
  validates :password, presence: true, length: { minimum: 6 }

  class << self
    # Returns the hash digest of the given string.
    def digest(string)
      cost = ActiveModel::SecurePassword.min_cost ? BCrypt::Engine::MIN_COST :
                                                    BCrypt::Engine.cost
      BCrypt::Password.create(string, cost: cost)
    end

    # Returns a random token.
    def new_token
      SecureRandom.urlsafe_base64
    end
  end

  def remember
    self.remember_token = User.new_token
    update_attribute(:remember_digest, User.digest(remember_token))
  end

  def authenticated?(remember_token)
    return false if remember_digest.nil?
    BCrypt::Password.new(remember_digest).is_password?(remember_token)
  end

  def forget
    update_attribute(:remember_digest, nil)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  include SessionsHelper
end

app/controllers/events_controller.rb
class EventsController < ApplicationController

  before_action :set_event, only: [:show, :destroy, :subscribe]
  def index
    @events = Event.all
  end

  def new
    @event = Event.new
  end

  def create
    @event = Event.create(event_params)
    @event.creator = current_user
    if @event.save
      flash.now[:success] = "Success"
      redirect_to current_user
    else
      render 'new'
    end
  end

  def show
  end

  def subscribe
    @event.attendees << current_user
    flash.now[:success] = "Participation with success"
    redirect_to root_path
  end

  def invite
    @event = Event.find(params[:event_id])
    @user = User.find(params[:id])
    puts @event.inspect
    @event.attendees << @user
    flash.now[:success] = "Participation with success"
    redirect_to @event
  end

  def destroy
    @event.destroy
    flash.now[:success] = "Delete with success !"
    redirect_to current_user
  end

  private
  def event_params
    params.require(:event).permit(:description, :date, :place, :creator_id)
  end

  def set_event
    @event = Event.find(params[:id])
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
    user = User.find_by(email: params[:session][:email].downcase)
    if user && user.authenticate(params[:session][:password])
      log_in user
      params[:session][:remember_me] == '1' ? remember(user) : forget(user)
      redirect_to root_path
    else
      flash.now[:danger] = 'VOUS NE PASSEREZ PAS !'
      render 'new'
    end
  end

  def destroy
    logout if logged_in?
    redirect_to root_url
  end
end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController

  def home
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController

  def index
    @event = Event.find(params[:event_id])
    @users = User.all
    puts @event.inspect
  end

  def new
    @user = User.new
  end

  def create
    @user = User.create(user_params)
    if @user.save
      log_in @user
      flash[:success] = "Bienvenido !"
      redirect_to @user
    else
      render 'new'
    end
  end

  def show
    current_user
  end

  private
  def user_params
    params.require(:user).permit(:name, :email, :password, :password_confirmation)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/events_helper.rb
module EventsHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper

  def log_in(user)
    session[:user_id] = user.id
  end

  def remember(user)
    user.remember
    cookies.permanent.signed[:user_id] = user.id
    cookies.permanent[:remember_token] = user.remember_token
  end

  # Returns the user corresponding to the remember token cookie.
  def current_user
    if (user_id = session[:user_id])
      @current_user ||= User.find_by(id: user_id)
    elsif (user_id = cookies.signed[:user_id])
      user = User.find_by(id: user_id)
      if user && user.authenticated?(cookies[:remember_token])
        log_in user
        @current_user = user
      end
    end
  end

  def logged_in?
    !current_user.nil?
  end

  def forget(user)
    user.forget
    cookies.delete(:user_id)
    cookies.delete(:remember_token)
  end

  def logout
    forget(current_user)
    session.delete(:user_id)
    @current_user = nil
  end

end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/helpers/users_helper.rb
module UsersHelper

  def invitations
    User.all.reject{|user| user == current_user}
  end
end

app/views/events/index.html.erb
<h1>Welcome !</h1>
<h2>Tu veux créer un évènement ?</h2>
<%= render 'layouts/new_event' %>
<br>
<div class="center jumbotron">
  <h3>Actuels</h3>
  <br>
  <% if !@events.current.any? %>
    <div>Aucun évènement</div>
  <% else %>
    <%= render 'layouts/current_events' %>
  <% end %>
</div>

<div class="center jumbotron">
  <h3>Passés</h3>
  <br>
  <% if !@events.past.any? %>
    <div>Aucun évènement</div>
  <% else %>
    <%= render 'layouts/past_events' %>
  <% end %>
</div>

app/views/events/new.html.erb
<% provide(:title, 'Nouvel event') %>
<h1>Nouvel event</h1>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@event, url: new_event_path) do |f| %>

      <%= f.label :date %>
      <%= f.date_field :date, class: 'form-control' %>

      <%= f.label :lieu %>
      <%= f.text_field :place, class: 'form-control' %>

      <%= f.label :description %>
      <%= f.text_area :description, class: 'form-control' %>

      <%= f.submit "Créer", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/events/show.html.erb
<h1>Event</h1>
<h2>Organisateur : <%= @event.creator.name %></h2>
<h2><%= @event.place %></h2>
<h2><%= @event.description %></h2>
<h2><%= @event.date.strftime("%d %B %Y") %></h2>
<div class="center jumbotron">
  <h3>Liste des participants</h3>
  <br>
  <% if !@event.attendees.any? %>
    <div>Aucun participant</div>
  <% else %>
    <table class="event-show">
      <thead>
        <tr>
          <th>ID</th>
          <th>Nom</th>
          <th>Email</th>
        </tr>
      </thead>

      <tbody>
        <% @event.attendees.each do |attendee| %>
          <tr>
            <td><%= attendee.id%></td>
            <td><%= attendee.name%></td>
            <td><%= attendee.email %></td>
          </tr>
        <% end %>
      </tbody>
    </table>
  <% end %>
</div>

<div class="center jumbotron">
  <h3>Envoyer des invitations</h3>
  <br>
  <% if invitations.count == @event.attendees.reject{|user| user == current_user}.count %>
    <div>Aucune invitation à envoyer</div>
  <% else %>
    <table>
      <thead>
        <tr>
          <th>ID</th>
          <th>Name</th>
          <th>Email</th>
          <th></th>
        </tr>
      </thead>

      <tbody>

        <% invitations.each do |user| %>
          <% unless @event.attendees.include? user %>
            <tr>
              <td><%= user.id %></td>
              <td><%= user.name %></td>
              <td><%= user.email %></td>
              <td><%= link_to 'Inviter', {:controller => "events", :action => "invite", :id => user.id, :event_id => @event.id}, :class=>"btn btn-sm btn-success" %></td>
            </tr>
          <% end %>
        <% end %>
      </tbody>
    </table>
  <% end %>
</div>

app/views/layouts/_current_events.html.erb
<table class="table-hover">
  <thead>
    <tr>
      <th>Date</th>
      <th>Lieu</th>
      <th>Créateur</th>
    </tr>
  </thead>

  <tbody>
    <% @events.current.sort{|a,b| a.date <=> b.date}.each do |event| %>
      <tr>
        <td><%= event.date.strftime("%d-%b-%Y") %></td>
        <td><%= event.place %></td>
        <td><%= event.creator.name %></td>
        <% if logged_in? %>
          <td class="buttons">
            <%= link_to 'Show', event, :class=>"btn btn-sm btn-info", :method=>:get%>
          <% if !(event.attendees.include? current_user) %>
              <%= link_to 'Participer',subscribe_path(id: event.id) , :class=>"btn btn-sm btn-primary", :method=>:post %>
            <% end %>
            <% if current_user == event.creator %>
              <%= link_to 'Invite', event_users_path(event), :class=>"btn btn-sm btn-success", :method=>:get%>
              <%= link_to 'Delete', event, :class=>"btn btn-sm btn-danger", :method=>:delete%></td>
              <% end %>
        <% end %>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/layouts/_footer.html.erb
<footer class="footer">
  <small>
    L'app de Daniel
  </small>
  <nav>
    <ul>
      <li><%= link_to "Rien",   '#' %></li>
      <li><%= link_to "Du", '#' %></li>
      <li><%= link_to "Tout", '#' %></li>
    </ul>
  </nav>
</footer>

app/views/layouts/_header.html.erb
<header class="navbar navbar-fixed-top navbar-inverse">
  <div class="container">
    <%= link_to "Eventbrite-like", root_path, id: "logo" %>
    <nav>
      <ul class="nav navbar-nav navbar-right">
        <li><%= link_to "Accueil", root_path %></li>
        <% if logged_in? %>
          <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
              <%=current_user.name %>
              <b class="caret"></b>
            </a>
            <ul class="dropdown-menu">
              <li><%= link_to "Mon Compte", current_user %></li>
              <li class="divider"></li>
              <li>
                <%= link_to "Log out", logout_path, method: :delete %>
              </li>
            </ul>
          </li>
        <% else %>
          <li><%= link_to "Sign up", signup_path %></li>
          <li><%= link_to "Log in", login_path %></li>
        <% end %>

      </ul>
    </nav>
  </div>
</header>

app/views/layouts/_new_event.html.erb
<% if logged_in? %>
  <table>
    <tr>
      <td>
        <%= link_to "Créer un nouvel event", 'new_event', class: "btn btn-lg btn-primary" %>
      </td>
    </tr>
  </table>
<% else %>
  <table style="width:90%;">
    <tr>
      <th><h3>..mais avant inscris toi !</h3></th>
      <th><h3>..connecte toi !</h3></th>
    </tr>
    <tr>
      <td><%= link_to "Inscris toi!", 'signup', class: "btn btn-lg btn-info" %></td>
      <td><%= link_to "Connecte toi!", 'login', class: "btn btn-lg btn-info" %></td>
    </tr>
    <tr>
      <td colspan=2>
        <%= link_to "Créer un nouvel event", 'login', class: "btn btn-lg btn-primary" %>
      </td>
    </tr>
  </table>

<% end %>

app/views/layouts/_past_events.html.erb
<table class="table-hover index">
  <thead>
    <tr>
      <th>Date</th>
      <th>Lieu</th>
      <th>Créateur</th>
    </tr>
  </thead>

  <tbody>
    <% if !@events.nil? %>
      <% @events.past.sort{|a,b| a.date <=> b.date}.each do |event| %>
        <tr>
          <td><%= event.date.strftime("%d-%b-%Y") %></td>
          <td><%= event.place %></td>
          <td><%= event.creator.name %></td>
          <% if logged_in? %>
            <td><%= link_to 'Show', event, :class=>"btn btn-sm btn-info", :method=>:get%></td>
            <% end %>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>EventbriteLike</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/header' %>

    <div class="container">
      <% flash.each do |message_type, message| %>
        <div class="alert alert-<%= message_type %>"><%= message %></div>
      <% end %>

      <%= yield %>
      <%= render 'layouts/footer' %>
    </div>

  </body>
</html>

app/views/shared/_error_current.html.erb
<% if current_user.errors.any? %>
  <div id="error_explanation">
    <div class="alert alert-danger">
      The form contains <%= pluralize(current_user.errors.count, "error") %>.
    </div>
    <ul>
    <% current_user.errors.full_messages.each do |msg| %>
      <li><%= msg %></li>
    <% end %>
    </ul>
  </div>
<% end %>

app/views/shared/_error_messages.html.erb
<% if @user.errors.any? %>
  <div id="error_explanation">
    <div class="alert alert-danger">
      The form contains <%= pluralize(@user.errors.count, "error") %>.
    </div>
    <ul>
    <% @user.errors.full_messages.each do |msg| %>
      <li><%= msg %></li>
    <% end %>
    </ul>
  </div>
  <% end %>

app/views/static_pages/home.html.erb
<h1>Welcome !</h1>
<h2>Tu veux créer un évènement ?</h2>
<%= render 'layouts/new_event' %>
<br>
<div class="center jumbotron">
  <table>
    <thead>
      <tr>
        <th>Date</th>
        <th>Lieu</th>
        <th>Créateur</th>
        <th colspan="3"></th>
      </tr>
    </thead>

    <tbody>
      <% if !@events.nil? %>
        <% @events.each do |event| %>
          <tr>
            <td><%= event.date %></td>
            <td><%= event.place %></td>
            <td><%= event.creator %></td>
            <td><%= button_to 'Show', event, :class=>"btn btn-sm btn-outline-info", :method=>:get%></td>
            <td><%= button_to 'Edit', edit_event_path(event), :class=>"btn btn-sm btn-outline-warning", :method=>:get%></td>
          </tr>
        <% end %>
      <% end %>
    </tbody>
  </table>

</div>

app/views/users/index.html.erb
<h1>Invitations</h1>

<table>
  <thead>
    <tr>
      <th>ID</th>
      <th>Name</th>
      <th>Email</th>
    </tr>
  </thead>

  <tbody>
    <% @users.reject{|user| user == current_user}.each do |user| %>
      <% unless @event.attendees.include? user %>
        <tr>
          <td><%= user.id %></td>
          <td><%= user.name %></td>
          <td><%= user.email %></td>
          <td><%= link_to 'Inviter', {:controller => "events", :action => "invite", :id => user.id, :event_id => @event.id}, :class=>"btn btn-sm btn-success" %></td>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

<br>

app/views/users/new.html.erb
<% provide(:title, 'Sign up') %>
<h1>Inscription</h1>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@user, url: signup_path) do |f| %>
      <%= render 'shared/error_messages' %>

      <%= f.label :name %>
      <%= f.text_field :name, class: 'form-control' %>

      <%= f.label :email %>
      <%= f.email_field :email, class: 'form-control' %>

      <%= f.label :password %>
      <%= f.password_field :password, class: 'form-control' %>

      <%= f.label :password_confirmation, "Confirmation" %>
      <%= f.password_field :password_confirmation, class: 'form-control' %>

      <%= f.submit "Créer", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/users/show.html.erb
<% provide(:title, current_user.name) %>
<h1><%= current_user.name %></h1>
<h2><%= current_user.email %></h2>
<div class="center jumbotron">
  <h2>Créés</h2>

  <% if !current_user.created_events.any? %>
    <div>Aucun évènement</div>
    <br>
  <% else %>
  <table class="table-hover">
    <thead>
      <tr>
        <th>Event</th>
        <th>Date</th>
        <th>Lieu</th>
      </tr>
    </thead>

    <tbody>
      <% current_user.created_events.each do |event| %>
        <tr>
          <td><%= event.description%></td>
          <td><%= event.date.strftime("%d-%b-%Y") %></td>
          <td><%= event.place %></td>
          <td>
            <%= link_to 'Invite', event_users_path(event), :class=>"btn btn-sm btn-success", :method=>:get%>
            <%= link_to 'Show', event, :class=>"btn btn-sm btn-info", :method=>:get%>
            <%= link_to 'Delete', event, :class=>"btn btn-sm btn-danger", :method=>:delete%>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <% end %>
  <br>
  <div>
    <%= link_to "Créer un nouvel event", new_event_path, class: "btn btn-lg btn-primary" %>
  </div>
</div>

<br />

<div class="center jumbotron">
  <h2>Participation</h2>

  <% if !current_user.attended_events.any? %>
    <div>Aucun évènement</div>
  <% else %>
  <table class="table-hover">
    <thead>
      <tr>
        <th>Event</th>
        <th>Date</th>
        <th>Lieu</th>
      </tr>
    </thead>

    <tbody>
      <% current_user.attended_events.each do |event| %>
        <tr>
          <td><%= event.description%></td>
          <td><%= event.date.strftime("%d-%b-%Y") %></td>
          <td><%= event.place %></td>
          <td><%= link_to 'Show', event, :class=>"btn btn-sm btn-info", :method=>:get%></td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <% end %>
</div>

<div class="center jumbotron">
  <h2>Évènements passés</h2>
  <% if !current_user.attended_events.past.any? %>
    <div>Aucun évènement</div>
  <% else %>
  <table class="table-hover">
    <thead>
      <tr>
        <th>Event</th>
        <th>Date</th>
        <th>Lieu</th>
      </tr>
    </thead>

    <tbody>
      <% current_user.attended_events.past.each do |event| %>
        <tr>
          <td><%= event.description%></td>
          <td><%= event.date.strftime("%d/%b/%Y") %></td>
          <td><%= event.place %></td>
          <td><%= link_to 'Show', event, :class=>"btn btn-sm btn-info", :method=>:get%></td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <% end %>
</div>